#-*- coding: cp1252 -*-
 
# Erik Gracia. 2010
 
# MEN.
 
# Imports:
import pygame
from pygame.locals import *
import pygame.mixer
import sys
from creditos import *



# Programa:
class Menu:
    
    def __init__(self):
        self.opciones = [
        ("Comenzar aventura", self.comenzar_nuevo_juego),
        ["Sonido", self.musica_on_off],
        ("Instrucciones", self.instrucciones),
        ("Creditos", self.creditos),
        ("Salir", self.salir_del_programa)
        ]
        self.seleccionado = 0
        self.total = len(self.opciones)
        self.mantiene_pulsado = False
        self.fondo = pygame.image.load("Img/menuimg.PNG")
        self.font = pygame.font.SysFont('Type Knight', 48)
        self.cancioncilla = pygame.mixer.music.load("summoning.mp3")
        self.cancioncilla = pygame.mixer.music.play()
        self.musica = True
        self.fondoins = True
        self.fondocre = True
        self.salirins = False
        self.salircre = False
        self.estado = 1
        self.fondoins = pygame.image.load("Img/instrucciones.PNG")
        self.fondocre = pygame.image.load("Img/creditos.PNG")
        

    def actualizar(self):

        k = pygame.key.get_pressed()

        if not self.mantiene_pulsado:
            if k[K_UP]:
                self.seleccionado -= 1
            elif k[K_DOWN]:
                self.seleccionado += 1
            elif k[K_RETURN]:

                # Invoca a la funcin asociada a la opcin.
                titulo, funcion = self.opciones[self.seleccionado]
                print "Selecciona la opcin '%s'." %(titulo)
                funcion()

        # procura que el cursor est entre las opciones permitidas
        if self.seleccionado < 0:
            self.seleccionado = 0
        elif self.seleccionado > self.total - 1:
            self.seleccionado = self.total - 1

        # indica si el usuario mantiene pulsada alguna tecla.
        self.mantiene_pulsado = k[K_UP] or k[K_DOWN] or k[K_RETURN]


    def imprimir(self, screen):
        
        indice = 0
        altura_de_opcion = 45
        x = 390
        y = 108
        screen.blit(self.fondo, (0, 0))
        for (titulo, funcion) in self.opciones:
            if indice == self.seleccionado:
                color = (255, 255, 255)
            elif indice == 1 and self.musica == False:
                color = (150, 0, 0)
            else:
                color = (255, 0, 0)

            imagen = self.font.render(titulo, 1, color)
            posicion = (x, y + altura_de_opcion * indice)
            indice += 1
            screen.blit(imagen, posicion)


    def comenzar_nuevo_juego(self):
        self.estado = 2
        self.cancioncilla = pygame.mixer.music.stop()
        self.cancioncilla = pygame.mixer.music.play()
    
    def musica_on_off(self):
        if self.musica == True:
            self.musica = False
            self.opciones[1][0] = "Sin Sonido"
            self.cancioncilla = pygame.mixer.music.pause()
        else:
            self.musica = True
            self.opciones [1][0] = "Sonido"
            self.cancioncilla = pygame.mixer.music.unpause()
    
    def instrucciones(self):
        self.estado = 3
        
    def imprime_instrucciones(self, screen):
        screen.blit(self.fondoins, (0,0))
        presionada = pygame.key.get_pressed()    
        if presionada[K_BACKSPACE]:
            self.estado = 1
            
        
        
    def creditos(self):
        self.estado = 4
    
    def imprime_creditos(self, screen):
        screen.blit(self.fondocre, (0,0))
        presionada = pygame.key.get_pressed()    
        if presionada[K_BACKSPACE]:
            self.estado = 1
              

    def salir_del_programa(self):
        print " Gracias por utilizar este programa."
        sys.exit(0)
